> ## Documentation Index
> Fetch the complete documentation index at: https://docs.reap.global/llms.txt
> Use this file to discover all available pages before exploring further.

# Respond to 3DS challenge

> Approves or rejects a 3DS authentication challenge. Must respond within 5 minutes of the challenge being created.



## OpenAPI

````yaml /api-reference/openapi.json post /card-3ds-challenges/{challengeId}/respond
openapi: 3.1.0
info:
  title: Reap API
  version: 1.0.0
  description: Reap platform API
servers:
  - url: https://sandbox.api.reap.global
    description: Sandbox
  - url: https://prod.api.reap.global
    description: Production
security:
  - bearerAuth: []
tags:
  - name: Accounts
  - name: Activities
  - name: Card Designs
  - name: Card Shipments
  - name: Card Transactions
  - name: Cards
  - name: Companies
  - name: Crypto Deposits
  - name: Policies
  - name: Simulation
  - name: Users
  - name: Virtual Asset Postings
  - name: Virtual Assets
  - name: Webhooks
paths:
  /card-3ds-challenges/{challengeId}/respond:
    post:
      tags:
        - Cards
      summary: Respond to 3DS challenge
      description: >-
        Approves or rejects a 3DS authentication challenge. Must respond within
        5 minutes of the challenge being created.
      operationId: respondToThreeDsChallenge_cards
      parameters:
        - name: challengeId
          in: path
          required: true
          schema:
            type: string
            format: uuid
        - name: Reap-Version
          in: header
          required: true
          schema:
            type: string
            enum:
              - '2025-02-14'
            description: API version (YYYY-MM-DD)
            example: '2025-02-14'
      requestBody:
        description: Request body for responding to a 3DS challenge
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                approve:
                  type: boolean
                  description: Whether to approve or reject the 3DS challenge
              required:
                - approve
          application/x-www-form-urlencoded:
            schema:
              type: object
              properties:
                approve:
                  type: boolean
                  description: Whether to approve or reject the 3DS challenge
              required:
                - approve
          multipart/form-data:
            schema:
              type: object
              properties:
                approve:
                  type: boolean
                  description: Whether to approve or reject the 3DS challenge
              required:
                - approve
      responses:
        '200':
          description: 3DS challenge response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ThreeDsChallenge'
        '404':
          description: Response for status 404
          content:
            application/json:
              schema:
                anyOf:
                  - type: object
                    properties:
                      error:
                        type: object
                        properties:
                          code:
                            type: string
                            const: 3DS_CHALLENGE_NOT_FOUND
                          message:
                            type: string
                          detail:
                            anyOf:
                              - type: object
                                additionalProperties: {}
                              - type: 'null'
                        required:
                          - code
                          - message
                          - detail
                    required:
                      - error
                    title: ThreeDsChallengeNotFoundError
                    description: 3DS challenge not found
                  - type: object
                    properties:
                      error:
                        type: object
                        properties:
                          code:
                            type: string
                            const: CARD_NOT_FOUND
                          message:
                            type: string
                          detail:
                            anyOf:
                              - type: object
                                additionalProperties: {}
                              - type: 'null'
                        required:
                          - code
                          - message
                          - detail
                    required:
                      - error
                    title: CardNotFoundError
                    description: Card not found
        '409':
          description: 3DS challenge has already been responded to
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                        const: 3DS_CHALLENGE_ALREADY_RESPONDED
                      message:
                        type: string
                      detail:
                        anyOf:
                          - type: object
                            additionalProperties: {}
                          - type: 'null'
                    required:
                      - code
                      - message
                      - detail
                required:
                  - error
                title: ThreeDsChallengeAlreadyRespondedError
        '410':
          description: 3DS challenge has expired
          content:
            application/json:
              schema:
                type: object
                properties:
                  error:
                    type: object
                    properties:
                      code:
                        type: string
                        const: 3DS_CHALLENGE_EXPIRED
                      message:
                        type: string
                      detail:
                        anyOf:
                          - type: object
                            additionalProperties: {}
                          - type: 'null'
                    required:
                      - code
                      - message
                      - detail
                required:
                  - error
                title: ThreeDsChallengeExpiredError
components:
  schemas:
    ThreeDsChallenge:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique 3DS challenge identifier
        cardId:
          type: string
          format: uuid
          description: ID of the card this challenge is for
        status:
          type: string
          enum:
            - PENDING
            - APPROVED
            - REJECTED
            - EXPIRED
          description: Challenge status
          example: PENDING
        merchant:
          $ref: '#/components/schemas/ThreeDsChallengeMerchant'
        transaction:
          $ref: '#/components/schemas/ThreeDsChallengeTransaction'
        expiresAt:
          type: string
          examples:
            - '2024-01-15T10:35:00Z'
          description: ISO 8601 timestamp when this challenge expires
      required:
        - id
        - cardId
        - status
        - merchant
        - transaction
        - expiresAt
    ThreeDsChallengeMerchant:
      type: object
      properties:
        name:
          type: string
          examples:
            - Sephora Digital
          description: Merchant name
        countryCode:
          type: string
          examples:
            - '344'
          description: Merchant country code (ISO numeric)
      required:
        - name
        - countryCode
      description: Merchant details
    ThreeDsChallengeTransaction:
      type: object
      properties:
        amount:
          type: string
          examples:
            - '170.0000'
          description: Transaction amount
        currency:
          type: string
          examples:
            - HKD
            - USD
          description: Transaction currency (ISO alpha-3)
        timestamp:
          type: string
          examples:
            - '2024-01-15T10:30:00Z'
          description: ISO 8601 timestamp of the transaction
      required:
        - amount
        - currency
        - timestamp
      description: Transaction details
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key as Bearer token

````